#include <stdio.h>
#include <windows.h>
//#include <mmreg.h>
//#include <msacm.h>
//#include <math.h>

#include "in2.h"
#include "common.h"

// ------------------------- * Global * -------------------------

In_Module mod; // the output module (declared near the bottom of this file)
char lastfn[MAX_PATH]; // currently playing file (used for getting info on the current file)
int file_length, mus_length; // file length, in bytes
int decode_pos_ms; // current decoding position, in milliseconds
int paused; // are we paused?
int seek_needed; // if != -1, it is the point that the decode thread should seek to, in ms.
char sample_buffer[576*NCH*(BPS/8)*2]; // sample buffer

HANDLE input_file=INVALID_HANDLE_VALUE; // input file handle
char *buffer=NULL;	// file data buffer

int killDecodeThread=0;					// the kill switch for the decode thread
HANDLE thread_handle=INVALID_HANDLE_VALUE;	// the handle to the decode thread

DWORD WINAPI __stdcall DecodeThread(int *b); // the decode thread procedure

// ------------------------- * Devider * -------------------------

// avoid CRT. Evil. Big. Bloated.
BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}

void main(void){}

// ------------------------- * Devider * -------------------------

void config(HWND hwndParent)
{
// if we had a configuration we'd want to write it here :)
	MessageBox(hwndParent, "No configuration.", "Configuration",MB_OK);
}
void about(HWND hwndParent)
{
	MessageBox(hwndParent,
		"DarkOne's IMF /Wolfenstein 3D/ Music Player\n\n"
		"Created by DarkOne\n"
		"http://wolfgl.narod.ru\n"
		"DarkOne@navigators.lv",
		"About IMF Player", MB_OK);
}

// any one-time initialization goes here (configuration reading, etc)
void init(void)
{
}

// one-time deinit, such as memory freeing
void quit(void)
{
}

// used for detecting URL streams..
// unused here. strncmp(fn,"http://",7) to detect HTTP streams, etc
int isourfile(char *fn)
{
	return 0;
} 

int play(char *fn) 
{ 
	int maxlatency;
	int thread_id;
	unsigned long l;

// open input file
	input_file=CreateFile(fn, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL,
														OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(input_file==INVALID_HANDLE_VALUE) return 1; // error opening file
	file_length=GetFileSize(input_file,NULL);

	buffer=GlobalAlloc(GMEM_FIXED, file_length);
	if(!buffer)
	{
		CloseHandle(input_file);
		input_file=INVALID_HANDLE_VALUE;
		return 1;
	}
	ReadFile(input_file, buffer, file_length, &l, NULL);
	CloseHandle(input_file);
	input_file=INVALID_HANDLE_VALUE;
	mus_length=SD_GetLen(buffer);

	SD_MusInit();
	SD_LoadMusic(buffer);

// variable init
	strcpy(lastfn, fn);
	paused=0; decode_pos_ms=0; seek_needed=-1;

// open Output device
	maxlatency=mod.outMod->Open(SAMPLERATE, NCH, BPS, -1, -1);
	if(maxlatency<0) // error opening device
	{
		SD_ShutDown();
		GlobalFree(buffer); buffer=NULL;
		return 1;
	}

// dividing by 1000 for the first parameter of setinfo makes it
// display 'H'... for hundred.. i.e. 14H Kbps.
	mod.SetInfo(8*file_length/mus_length, SAMPLERATE/1000, NCH, 1);

// initialize vis stuff
	mod.SAVSAInit(maxlatency,SAMPLERATE);
	mod.VSASetInfo(SAMPLERATE,NCH);

// set the output plug-ins default volume
	mod.outMod->SetVolume(-666); 

	killDecodeThread=0;
	thread_handle=(HANDLE)CreateThread(NULL, 0, DecodeThread, (void *)&killDecodeThread, 0, &thread_id);
	
	return 0; 
}

void   pause(void) {paused=1; mod.outMod->Pause(1);}
void unpause(void) {paused=0; mod.outMod->Pause(0);}
int ispaused(void) {return paused;}

void stop(void)
{ 
	if(thread_handle!=INVALID_HANDLE_VALUE)
	{
		killDecodeThread=1;
		if(WaitForSingleObject(thread_handle, INFINITE)==WAIT_TIMEOUT)
		{
			MessageBox(mod.hMainWindow, "error asking thread to die!\n", "error killing decode thread", 0);
			TerminateThread(thread_handle, 0);
		}
		CloseHandle(thread_handle);
		thread_handle=INVALID_HANDLE_VALUE;
	}

	if(buffer!=NULL) {GlobalFree(buffer); buffer=NULL;}
	SD_ShutDown();

	mod.outMod->Close();
	mod.SAVSADeInit();
}

int getlength(void)
{
	return mus_length;
}

int getoutputtime(void)
{
	return decode_pos_ms+(mod.outMod->GetOutputTime()-mod.outMod->GetWrittenTime());
}

void setoutputtime(int time_in_ms)
{
	seek_needed=time_in_ms; 
}

void setvolume(int volume) {mod.outMod->SetVolume(volume);}
void setpan(int pan) {mod.outMod->SetPan(pan);}

int infoDlg(char *fn, HWND hwnd)
{
	// TODO: implement info dialog. 
	return 0;
}

void getfileinfo(char *filename, char *title, int *length_in_ms)
{
	if(!filename || !*filename)  // currently playing file
	{
		if(length_in_ms)
			*length_in_ms=getlength();
		if(title && lastfn) 
		{
			char *p, *p1;

			p1=p=lastfn; while(*p) if(*p++=='\\') p1=p;
			strcpy(title, p1);
		}
	}
	else // some other file
	{
		if(length_in_ms) 
		{
			HANDLE hFile;
			char *b;
			int file_len, l;

			*length_in_ms=-1000;
			hFile=CreateFile(filename, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, 
																 OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
			if(hFile!=INVALID_HANDLE_VALUE)
			{
				file_len=GetFileSize(hFile, NULL);
				b=GlobalAlloc(GMEM_FIXED, file_len);
				if(b)
				{
					ReadFile(hFile, b, file_len, &l, NULL);
					*length_in_ms=SD_GetLen(b);
					GlobalFree(b);
				}
				CloseHandle(hFile);
			}
		}
		if(title)
		{
			char *p, *p1;

			p1=p=filename; while(*p) if(*p++=='\\') p1=p;
			strcpy(title, p1);
		}
	}
}

void eq_set(int on, char data[10], int preamp) 
{ 
	// most plug-ins can't even do an EQ anyhow.. I'm working on writing
	// a generic PCM EQ, but it looks like it'll be a little too CPU 
	// consuming to be useful :)
}


// render 576 samples into buf. 
// note that if you adjust the size of sample_buffer, for say, 1024
// sample blocks, it will still work, but some of the visualization 
// might not look as good as it could. Stick with 576 sample blocks
// if you can, and have an additional auxiliary (overflow) buffer if 
// necessary.. 
int get_576_samples(char *buf)
{
	return UpdateMusic(0, 567*NCH*(BPS/8), buf);
}

DWORD WINAPI __stdcall DecodeThread(int *b)
{
	int done=0;

	while(!*b) 
	{
		if(seek_needed!=-1)
		{
			decode_pos_ms=seek_needed-(seek_needed%1000);
			seek_needed=-1;
			done=0;
			mod.outMod->Flush(decode_pos_ms);

			decode_pos_ms=1000*(Seek((decode_pos_ms/1000)*ADLIB_MUS_BYPS)/ADLIB_MUS_BYPS);
			if(decode_pos_ms<0) done=1;
		}
		if(done)
		{
			mod.outMod->CanWrite();
			if(!mod.outMod->IsPlaying())
			{
				PostMessage(mod.hMainWindow, WM_WA_MPEG_EOF, 0, 0);
				return 0;
			}
			Sleep(10);
		}
		else if(mod.outMod->CanWrite()>=((567*NCH*(BPS/8))<<(mod.dsp_isactive()?1:0)))
		{	
			int l;

			l=get_576_samples(sample_buffer);
			if(!l)
				done=1;
			else
			{
				mod.SAAddPCMData((char *)sample_buffer, NCH, BPS, decode_pos_ms);
				mod.VSAAddPCMData((char *)sample_buffer, NCH, BPS, decode_pos_ms);
				decode_pos_ms+=(567*1000)/SAMPLERATE;
				if(mod.dsp_isactive())
					l=mod.dsp_dosamples((short *)sample_buffer, l/(NCH*(BPS/8)), BPS, NCH, SAMPLERATE)*(NCH*(BPS/8));
				mod.outMod->Write(sample_buffer, l);
			}
		}
		else Sleep(20);
	}
	return 0;
}

// ------------------------- * Devider * -------------------------

In_Module mod=
{
	IN_VER,
	"DarkOne's IMF Player v0.0 (x86)",
	0,	// hMainWindow
	0,	// hDllInstance
	"IMF\0IMF Music File (*.IMF)\0",
	1,	// is_seekable
	1,	// uses output

	config,	about,
	init,	quit,
	getfileinfo, infoDlg,
	isourfile,
	play,	pause, unpause, ispaused, stop,
	getlength, getoutputtime, setoutputtime,
	setvolume, setpan,
	0,0,0,0,0,0,0,0,0, // vis stuff
	0,0,		// dsp
	eq_set,
	NULL,		// setinfo
	0				// out_mod
};

__declspec(dllexport) In_Module *winampGetInModule2()
{
	return &mod;
}
